'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var _jsxFileName = 'src/NativePasswordBox.js';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PasswordBoxBody = require('./PasswordBoxBody');

var _PasswordBoxBody2 = _interopRequireDefault(_PasswordBoxBody);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

exports.default = (0, _react.forwardRef)(function (props, ref) {
    var inputRef = (0, _react.useRef)();
    var value = props.value,
        className = props.className;

    var nativeClass = (0, _classnames2.default)('lm-pwd-cont', 'lm-password-box-def', '' + className);

    /*
    * 获取input value
    * callback value
    * */
    var handleChange = function handleChange(e) {
        e.preventDefault();
        var _passwordLen = props.passwordLen;
        var _value = e.target.value;
        if (_value.length > _passwordLen) {
            _value = _value.slice(0, _passwordLen);
        }

        props.onChange(_value);
    };

    /*
    * input dom 失去焦点
    * */
    (0, _react.useImperativeHandle)(ref, function () {
        return {
            onhandleBlur: function onhandleBlur() {
                inputRef && inputRef.current && inputRef.current.blur();
            }
        };
    }, [inputRef]);

    return _react2.default.createElement(
        'section',
        _defineProperty({ className: nativeClass, __source: {
                fileName: _jsxFileName,
                lineNumber: 35
            },
            __self: undefined
        }, '__self', undefined),
        _react2.default.createElement('input', _defineProperty({
            className: 'lm-pwd-input',
            type: props.inputType,
            value: value,
            maxLength: props.passwordLen,
            ref: inputRef,
            onChange: handleChange,
            onFocus: props.onClick,
            __source: {
                fileName: _jsxFileName,
                lineNumber: 36
            },
            __self: undefined
        }, '__self', undefined)),
        _react2.default.createElement(_PasswordBoxBody2.default, _defineProperty({
            value: value,
            passwordLen: props.passwordLen,
            isEncrypt: props.isEncrypt,
            hasAnimation: props.hasAnimation,
            hasError: props.hasError,
            classConfig: props.classConfig,
            contentType: props.contentType,
            animationDuration: props.animationDuration,
            __source: {
                fileName: _jsxFileName,
                lineNumber: 46
            },
            __self: undefined
        }, '__self', undefined))
    );
});
module.exports = exports['default'];