'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var _jsxFileName = 'src/index.js';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Created by zhaojianling<zhaojianling@58ganji.com>.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * ComponentName Password_box
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Desc 密码框
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * GroupName lm-component
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

require('./polyfill');

var _CustormPasswordBox = require('./CustormPasswordBox');

var _CustormPasswordBox2 = _interopRequireDefault(_CustormPasswordBox);

var _NativePasswordBox = require('./NativePasswordBox');

var _NativePasswordBox2 = _interopRequireDefault(_NativePasswordBox);

var _EyeButton = require('./EyeButton');

var _EyeButton2 = _interopRequireDefault(_EyeButton);

require('./index.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * @class Password_box
 * @extends React.Component
 * @desc Password_box Component for mobile
 */
var PasswordBox = function PasswordBox(props, ref) {
    var keyboardType = props.keyboardType,
        className = props.className,
        hasEyeButton = props.hasEyeButton,
        styleType = props.styleType,
        eyePos = props.eyePos;

    var _useState = (0, _react.useState)(props.isEncrypt),
        _useState2 = _slicedToArray(_useState, 2),
        isEncrypt = _useState2[0],
        setIsEncrypt = _useState2[1];

    var handleEyeButtonClick = function handleEyeButtonClick() {
        var _curIsEncryptValue = isEncrypt;

        setIsEncrypt(!_curIsEncryptValue);
    };

    var passwordBoxClass = (0, _classnames2.default)('lm-password-box', 'lm-password-type-' + styleType);

    if (hasEyeButton) {
        passwordBoxClass = (0, _classnames2.default)('' + passwordBoxClass, 'eye-pos-' + eyePos);
    }

    return _react2.default.createElement(
        'section',
        _defineProperty({ className: passwordBoxClass, __source: {
                fileName: _jsxFileName,
                lineNumber: 49
            },
            __self: undefined
        }, '__self', undefined),
        keyboardType === 'native' ? _react2.default.createElement(_NativePasswordBox2.default, _defineProperty({
            ref: ref,
            className: className,
            value: props.password,
            passwordLen: props.passwordLen,
            inputType: props.inputType,
            isEncrypt: isEncrypt,
            hasAnimation: props.hasAnimation,
            onChange: props.onChange,
            onClick: props.onClick,
            hasError: props.hasError,
            classConfig: props.classConfig,
            contentType: props.contentType,
            animationDuration: props.animationDuration,

            __source: {
                fileName: _jsxFileName,
                lineNumber: 52
            },
            __self: undefined
        }, '__self', undefined)) : _react2.default.createElement(_CustormPasswordBox2.default, _defineProperty({
            className: className,
            value: props.password,
            passwordLen: props.passwordLen,
            isEncrypt: isEncrypt,
            hasAnimation: props.hasAnimation,
            onClick: props.onClick,

            hasError: props.hasError,
            classConfig: props.classConfig,
            contentType: props.contentType,
            animationDuration: props.animationDuration,

            __source: {
                fileName: _jsxFileName,
                lineNumber: 69
            },
            __self: undefined
        }, '__self', undefined)),
        hasEyeButton ? _react2.default.createElement(_EyeButton2.default, _defineProperty({
            isEncrypt: isEncrypt,
            eyeButtonClassName: props.eyeButtonClassName,
            handleEyeButtonClick: handleEyeButtonClick,
            __source: {
                fileName: _jsxFileName,
                lineNumber: 86
            },
            __self: undefined
        }, '__self', undefined)) : null
    );
};

var ForwardPasswordBox = (0, _react.forwardRef)(PasswordBox);

ForwardPasswordBox.propTypes = {
    keyboardType: _propTypes2.default.oneOf(['native', 'custorm']), // 键盘类型    native || custorm
    password: _propTypes2.default.string, // 密码值
    passwordLen: _propTypes2.default.number, // 密码长度
    inputType: _propTypes2.default.string, // input type(keyboardType 为native 时有效)
    isEncrypt: _propTypes2.default.bool, // 是否加密
    hasAnimation: _propTypes2.default.bool, // 是否有动画
    className: _propTypes2.default.string, // 自定义组件类名
    onChange: _propTypes2.default.func, // 回调函数（keyboardType为native时用于父组件获取键盘输入值）
    onClick: _propTypes2.default.func, // 点击密码框时回调函数

    hasError: _propTypes2.default.bool, // 输入是否有错
    hasEyeButton: _propTypes2.default.bool, // 是否显示眼睛按钮
    eyeButtonClassName: _propTypes2.default.object, // 眼睛按钮的类名
    eyePos: _propTypes2.default.oneOf(['right', 'bottom']), // 眼睛位置
    styleType: _propTypes2.default.oneOf(['box', 'underline']), // 密码框的展示类型
    classConfig: _propTypes2.default.object, // 样式配置{usualClass: '', errorClass: ''}
    contentType: _propTypes2.default.oneOf(['circle', 'star']), // 内容类型
    animationDuration: _propTypes2.default.number // 完成动画所花费的时间，以毫秒计
};

ForwardPasswordBox.defaultProps = {
    keyboardType: 'custorm',
    password: '',
    passwordLen: 6,
    inputType: 'number',
    isEncrypt: true,
    hasAnimation: false,
    className: '',
    onChange: function onChange() {},
    onClick: function onClick() {},

    hasError: false,
    eyeButtonClassName: {
        openEyeClass: '',
        closeEyeClass: ''
    },
    hasEyeButton: false,
    eyePos: 'right',
    styleType: 'box',
    classConfig: {
        usualClass: '',
        errorClass: ''
    },
    contentType: 'circle',
    animationDuration: 300
};

exports.default = ForwardPasswordBox;
module.exports = exports['default'];