import React from 'react';
import PasswordItem from './PasswordBoxItem';


export default function PasswordBoxBody(props) {
    const {
        isEncrypt,
        value = '',
        hasAnimation,
        hasError,
        classConfig,
        contentType,
        animationDuration
    } = props;

    /*
     * string 变为 数组
     * */
    const stringToArray = (str, len = props.passwordLen) => {
        let _tempArr = str.split('').slice(0, len)
        let _emptyArr = Array.from({length: len - _tempArr.length}, () => '');
        return [..._tempArr, ..._emptyArr]
    }

    return (
        <div className="lm-pwd-body">
            {
                stringToArray(value).map((item, index) => {

                    return <PasswordItem
                        itemVal={ item }
                        hasAnimation={ hasAnimation }
                        isEncrypt= { isEncrypt }
                        key={ `key-pwd-item-${index}` }

                        hasError={ hasError }
                        classConfig={ classConfig }
                        contentType={ contentType }
                        animationDuration={ animationDuration }
                    />

                })
            }
        </div>
    )
}
